Index: oln/convert/nbh_to_se.hh
===================================================================
--- oln/convert/nbh_to_se.hh	(revision 130)
+++ oln/convert/nbh_to_se.hh	(working copy)
@@ -28,15 +28,9 @@
 #ifndef OLENA_CONVERT_NBH_TO_SE_HH
 # define OLENA_CONVERT_NBH_TO_SE_HH
 
-# include <oln/basics.hh>
+# include <oln/core/abstract/neighborhood.hh>
+# include <oln/core/2d/dpoint2d.hh>
 
-// because of the internal function in this file
-//# include <oln/basics1d.hh>
-# include <oln/basics2d.hh>
-//# include <oln/basics3d.hh>
-//# include <oln/core/1d/neighborhood1d.hh>
-# include <oln/core/2d/neighborhood2d.hh>
-//# include <oln/core/3d/neighborhood3d.hh>
 
 namespace oln {
   namespace convert {
@@ -45,10 +39,10 @@
     ** \see nbh_to_cse
     */
     template<class N>
-    oln_type_of(N, window)
+    oln_nbh_type_of(N, window)
     nbh_to_se(const oln::abstract::neighborhood<N>& nbh)
     {
-      oln_type_of(N, window) output;
+      oln_nbh_type_of(N, window) output;
 
       for (unsigned i = 0; i < nbh.card(); i++)
 	output.add(nbh[i]);
@@ -66,15 +60,15 @@
     ** \see nbh_to_cs
     */
     template<class N>
-    oln_type_of(N, window)
+    oln_nbh_type_of(N, window)
     nbh_to_cse(const oln::abstract::neighborhood<N>& nbh)
     {
-      oln_type_of(N, window) output;
+      oln_nbh_type_of(N, window) output;
 
       for (unsigned i = 0; i < nbh.card(); i++)
 	output.add(nbh[i]);
 
-      oln_type_of(N, dpoint) zero;
+      oln_nbh_type_of(N, dpoint) zero;
       dpoint_zero(zero);
       output.add(zero);
       return output;
Index: oln/basics2d.hh
===================================================================
--- oln/basics2d.hh	(revision 130)
+++ oln/basics2d.hh	(working copy)
@@ -36,7 +36,7 @@
 # include <oln/core/2d/image2d.hh>
 # include <oln/core/2d/fwd_piter2d.hh>
 # include <oln/core/2d/bkd_piter2d.hh>
-# include <oln/core/2d/fwd_witer2d.hh>
+# include <oln/core/2d/fwd_qiter2d.hh>
 # include <oln/core/2d/window2d.hh>
 # include <oln/core/2d/neighborhood2d.hh>
 
Index: oln/core/typedefs.hh
===================================================================
--- oln/core/typedefs.hh	(revision 0)
+++ oln/core/typedefs.hh	(revision 0)
@@ -0,0 +1,107 @@
+// Copyright (C) 2005 EPITA Research and Development Laboratory
+//
+// This file is part of the Olena Library.  This library is free
+// software; you can redistribute it and/or modify it under the terms
+// of the GNU General Public License version 2 as published by the
+// Free Software Foundation.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this library; see the file COPYING.  If not, write to
+// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
+// MA 02111-1307, USA.
+//
+// As a special exception, you may use this file as part of a free
+// software library without restriction.  Specifically, if other files
+// instantiate templates or use macros or inline functions from this
+// file, or you compile this file and link it with other files to
+// produce an executable, this file does not by itself cause the
+// resulting executable to be covered by the GNU General Public
+// License.  This exception does not however invalidate any other
+// reasons why the executable file might be covered by the GNU General
+// Public License.
+
+#ifndef OLENA_CORE_TYPEDEFS_HH
+# define OLENA_CORE_TYPEDEFS_HH
+
+// FIXME: rename this present file (?)
+
+
+# include <mlc/types.hh>
+# include <mlc/typedef.hh>
+# include <mlc/properties.hh>
+# include <mlc/to_string.hh>
+
+
+
+
+namespace oln
+{
+
+  mlc_equip_namespace_with_properties();
+
+  // category::image
+
+  mlc_decl_typedef(data_type);
+  mlc_decl_typedef(value_type);
+  mlc_decl_typedef(neighb_type);
+  mlc_decl_typedef(value_storage_type);
+  mlc_decl_typedef(storage_type);
+  mlc_decl_typedef(point_type);
+  mlc_decl_typedef(dpoint_type);
+  mlc_decl_typedef(image_type);
+  mlc_decl_typedef(concrete_type);
+
+  mlc_decl_typedef(piter_type);
+  mlc_decl_typedef(fwd_piter_type);
+  mlc_decl_typedef(bkd_piter_type);
+  mlc_decl_typedef(iter_type);
+
+  mlc_decl_typedef(delegated_type);
+  mlc_decl_typedef(size_type);
+  mlc_decl_typedef(se_type);
+  mlc_decl_typedef(window_type);
+
+  mlc_decl_typedef(image_neighbness_type);
+  mlc_decl_typedef(image_constness_type);
+  mlc_decl_typedef(image_dimension_type);
+  mlc_decl_typedef(image_typeness_type);
+  mlc_decl_typedef(image_valuedness_type);
+
+  // extension in image_operators
+  mlc_decl_typedef(output_type);
+  mlc_decl_typedef(input_type);
+  mlc_decl_typedef(input1_type);
+  mlc_decl_typedef(input2_type);
+
+  // category::window
+
+  mlc_decl_typedef(fwd_qiter_type);
+  mlc_decl_typedef(bkd_qiter_type);
+
+
+
+} // end of namespace oln
+
+
+
+// FIXME: memo...
+
+//   namespace category
+//   {
+//     struct data_storage;
+//     struct struct_elt;
+//     struct neighborhood;
+//     struct point;
+//     struct size;
+//     struct piter;
+//     struct niter;
+//     // FIXME: ...
+//   }
+
+
+#endif // ! OLENA_CORE_TYPEDEFS_HH
Index: oln/core/value_box.hh
===================================================================
--- oln/core/value_box.hh	(revision 130)
+++ oln/core/value_box.hh	(working copy)
@@ -29,7 +29,7 @@
 # define OLENA_CORE_VALUE_BOX_HH
 
 # include <iostream>
-# include <oln/core/properties.hh>
+# include <oln/core/abstract/image.hh>
 
 
 
Index: oln/core/apply.hh
===================================================================
--- oln/core/apply.hh	(revision 130)
+++ oln/core/apply.hh	(working copy)
@@ -31,7 +31,7 @@
 # include <mlc/fun.hh>
 
 # include <oln/basics.hh>
-# include <oln/core/abstract/op.hh>
+# include <oln/core/abstract/image_operator.hh>
 # include <oln/core/ch_value_type.hh>
 
 namespace oln {
@@ -46,27 +46,20 @@
     struct apply1_type;
   }
 
-  // Category.
-  template <typename F, typename I>
-  struct set_category< impl::apply1_type<F, I> >
-  {
-    typedef category::image ret;
-  };
-
   // Super type.
   template <typename F, typename I>
   struct set_super_type< impl::apply1_type<F, I> >
   {
     typedef typename ch_value_type<I,
 				   typename F::result_type>::ret output_type;
-    typedef typename abstract::op<output_type, impl::apply1_type<F, I> > ret;
+    typedef typename abstract::image_operator<output_type, impl::apply1_type<F, I> > ret;
   };
 
   namespace impl {
 
     template <typename F, typename I>
     struct apply1_type :
-      public abstract::op<
+      public abstract::image_operator<
         typename ch_value_type<I, typename F::result_type>::ret,
         apply1_type<F, I> >
     {
@@ -122,20 +115,13 @@
     struct apply2_type;
   }
 
-  // Category.
-  template <typename F, typename I1, typename I2>
-  struct set_category< impl::apply2_type<F, I1, I2> >
-  {
-    typedef category::image ret;
-  };
-
   // Super type.
   template <typename F, typename I1, typename I2>
   struct set_super_type< impl::apply2_type<F, I1, I2> >
   {
     typedef typename ch_value_type<I1,
 				   typename F::result_type>::ret output_type;
-    typedef typename abstract::op<output_type,
+    typedef typename abstract::image_operator<output_type,
 				  impl::apply2_type<F, I1, I2> > ret;
   };
 
@@ -143,7 +129,7 @@
 
     template <typename F, typename I1, typename I2>
     struct apply2_type :
-      public abstract::op<
+      public abstract::image_operator<
         typename ch_value_type<I1, typename F::result_type>::ret,
         apply2_type<F, I1, I2> >
     {
Index: oln/core/ch_value_type.hh
===================================================================
--- oln/core/ch_value_type.hh	(revision 130)
+++ oln/core/ch_value_type.hh	(working copy)
@@ -28,7 +28,7 @@
 #ifndef OLENA_CORE_CH_VALUE_TYPE_HH
 # define OLENA_CORE_CH_VALUE_TYPE_HH
 
-# include <oln/core/properties.hh>
+# include <oln/core/abstract/image.hh>
 
 namespace oln {
 
Index: oln/core/box.hh
===================================================================
--- oln/core/box.hh	(revision 130)
+++ oln/core/box.hh	(working copy)
@@ -28,8 +28,7 @@
 #ifndef OLENA_CORE_BOX_HH
 # define OLENA_CORE_BOX_HH
 
-# include <oln/core/properties.hh>
-# include <oln/core/abstract/entry.hh>
+# include <oln/core/abstract/image_entry.hh>
 
 namespace oln {
 
Index: oln/core/pw/times.hh
===================================================================
--- oln/core/pw/times.hh	(revision 130)
+++ oln/core/pw/times.hh	(working copy)
@@ -31,35 +31,40 @@
 # include <oln/core/pw/abstract/binary_function.hh>
 # include <oln/core/pw/literal.hh>
 # include <ntg/all.hh>
+# include <oln/core/pw/macros.hh>
 
 
 namespace oln {
 
+  // fwd decl
+  namespace pw {
+    template <typename L, typename R> struct times;
+  }
 
-  namespace pw { // means "point-wise"
+  // super type
+  template <typename L, typename R>
+  struct set_super_type < pw::times<L, R> > { typedef pw::abstract::binary_function<L, R, pw::times<L, R> > ret; };
 
-    // fwd decl
-    template <typename L, typename R> struct times;
+  // props
+  template <typename L, typename R>
+  struct set_props < category::pw, pw::times<L, R> >
+  {
+    typedef ntg_return_type(times,
+			    oln_pw_type_of(L, value),
+			    oln_pw_type_of(R, value)) value_type;
+  };
 
-    template <typename L, typename R>
-    struct traits < times<L, R> >
-    {
-      typedef abstract::binary_function<L, R, times<L, R> > super_type;
-      typedef typename traits<super_type>::point_type point_type;
-      typedef typename traits<super_type>::size_type  size_type;
-      typedef ntg_return_type(times,
-			      oln_pw_value_type(L),
-			      oln_pw_value_type(R)) value_type;
-    };
 
+  namespace pw {
+
     template <typename L, typename R>
     struct times : public abstract::binary_function < L, R, times<L, R> >
     {
       typedef times<L, R> self_type;
 
-      typedef oln_pw_point_type(self_type) point_type;
-      typedef oln_pw_value_type(self_type) value_type;
-      typedef oln_pw_size_type(self_type)  size_type;
+      typedef oln_pw_type_of(self_type, point) point_type;
+      typedef oln_pw_type_of(self_type, value) value_type;
+      typedef oln_pw_type_of(self_type, size)  size_type;
 
       typedef abstract::binary_function<L, R, self_type> super_type;
 
Index: oln/core/pw/image.hh
===================================================================
--- oln/core/pw/image.hh	(revision 130)
+++ oln/core/pw/image.hh	(working copy)
@@ -32,7 +32,7 @@
 # include <mlc/cmp.hh>
 # include <oln/core/box.hh>
 # include <oln/core/abstract/image_typeness.hh>
-# include <oln/core/abstract/entry.hh>
+# include <oln/core/abstract/image_entry.hh>
 # include <oln/core/pw/abstract/function.hh>
 
 // FIXME: remove
@@ -43,20 +43,28 @@
 namespace oln {
 
 
+  // fwd decl
+  namespace pw {
+    template <typename I> struct image;
+  }    
+
+  // super type
+  template <typename I>
+  struct set_super_type < pw::image<I> > { typedef pw::abstract::function< pw::image<I> > ret; };
+
+  // props
+  template <typename I>
+  struct set_props < category::pw, pw::image<I> >
+  {
+    typedef oln_type_of(I, point) point_type;
+    typedef oln_type_of(I, value) value_type;
+    typedef oln_type_of(I, size)  size_type;
+  };
+
+
   namespace pw { // means "point-wise"
 
-    // fwd decl
-    template <typename I> struct image;
-    
     template <typename I>
-    struct traits < image<I> >
-    {
-      typedef oln_type_of(I, point) point_type;
-      typedef oln_type_of(I, value) value_type;
-      typedef oln_type_of(I, size)  size_type;
-    };
-
-    template <typename I>
     struct image : public abstract::function < image<I> >
     {
       oln::box<const I> ima;
@@ -107,25 +115,18 @@
 
   // fwd decl
   template <typename F> class image_from_pw;
-  
-  // category
-  template <typename F>
-  struct set_category< image_from_pw<F> > { typedef category::image ret; };
 
   // super
   template <typename F>
-  struct set_super_type < image_from_pw<F> >
-  {
-    typedef abstract::image_entry< image_from_pw<F> > ret;
-  };
+  struct set_super_type < image_from_pw<F> > { typedef abstract::image_entry< image_from_pw<F> > ret; };
 
   // props
   template <typename F>
-  struct set_props < category::image, image_from_pw<F> > : public props_of <category::image>
+  struct set_props < category::image, image_from_pw<F> >
   {
-    typedef oln_pw_point_type(F) point_type;
-    typedef oln_pw_value_type(F) value_type;
-    typedef oln_pw_size_type(F)  size_type;
+    typedef oln_pw_type_of(F, point) point_type;
+    typedef oln_pw_type_of(F, value) value_type;
+    typedef oln_pw_type_of(F, size)  size_type;
 
     typedef mlc::no_type delegated_type;
 
@@ -159,14 +160,10 @@
       this->exact_ptr = this;
     }
 
-    /// typedefs
+    typedef oln_pw_type_of(F, point) point_type;
+    typedef oln_pw_type_of(F, value) value_type;
+    typedef oln_pw_type_of(F, size)  size_type;
 
-    typedef image_from_pw<F> self_type;
-
-    typedef oln_type_of(self_type, size)  size_type;
-    typedef oln_type_of(self_type, value) value_type;
-    typedef oln_type_of(self_type, point) point_type;
-
     const size_type& impl_size() const
     {
       return this->fun.size();
@@ -251,7 +248,7 @@
     template <typename F>
     bool check(const pw::abstract::function<F>& pred)
     {
-      mlc::eq< oln_typeness_of(oln_pw_value_type(F)), typeness::binary_tag >::ensure();
+      mlc::eq< oln_typeness_of(oln_pw_type_of(F, value)), typeness::binary_tag >::ensure();
       return oln::check(for_all_p(pred));
     }
 
Index: oln/core/pw/div.hh
===================================================================
--- oln/core/pw/div.hh	(revision 130)
+++ oln/core/pw/div.hh	(working copy)
@@ -31,35 +31,40 @@
 # include <oln/core/pw/abstract/binary_function.hh>
 # include <oln/core/pw/literal.hh>
 # include <ntg/all.hh>
+# include <oln/core/pw/macros.hh>
 
 
 namespace oln {
 
+  // fwd decl
+  namespace pw {
+    template <typename L, typename R> struct div;
+  }
 
-  namespace pw { // means "point-wise"
+  // super type
+  template <typename L, typename R>
+  struct set_super_type < pw::div<L, R> > { typedef pw::abstract::binary_function<L, R, pw::div<L, R> > ret; };
 
-    // fwd decl
-    template <typename L, typename R> struct div;
+  // props
+  template <typename L, typename R>
+  struct set_props < category::pw, pw::div<L, R> >
+  {
+    typedef ntg_return_type(div,
+			    oln_pw_type_of(L, value),
+			    oln_pw_type_of(R, value)) value_type;
+  };
 
-    template <typename L, typename R>
-    struct traits < div<L, R> >
-    {
-      typedef abstract::binary_function<L, R, div<L, R> > super_type;
-      typedef typename traits<super_type>::point_type point_type;
-      typedef typename traits<super_type>::size_type  size_type;
-      typedef ntg_return_type(div,
-			      oln_pw_value_type(L),
-			      oln_pw_value_type(R)) value_type;
-    };
 
+  namespace pw {
+
     template <typename L, typename R>
     struct div : public abstract::binary_function < L, R, div<L, R> >
     {
       typedef div<L, R> self_type;
 
-      typedef oln_pw_point_type(self_type) point_type;
-      typedef oln_pw_value_type(self_type) value_type;
-      typedef oln_pw_size_type(self_type)  size_type;
+      typedef oln_pw_type_of(self_type, point) point_type;
+      typedef oln_pw_type_of(self_type, value) value_type;
+      typedef oln_pw_type_of(self_type, size)  size_type;
 
       typedef abstract::binary_function<L, R, self_type> super_type;
 
Index: oln/core/pw/plus.hh
===================================================================
--- oln/core/pw/plus.hh	(revision 130)
+++ oln/core/pw/plus.hh	(working copy)
@@ -30,36 +30,41 @@
 
 # include <oln/core/pw/abstract/binary_function.hh>
 # include <oln/core/pw/literal.hh>
+# include <oln/core/pw/macros.hh>
 # include <ntg/all.hh>
 
 
 namespace oln {
 
+  // fwd decl
+  namespace pw {
+    template <typename L, typename R> struct plus;
+  }
 
-  namespace pw { // means "point-wise"
+  // super type
+  template <typename L, typename R>
+  struct set_super_type < pw::plus<L, R> > { typedef pw::abstract::binary_function<L, R, pw::plus<L, R> > ret; };
 
-    // fwd decl
-    template <typename L, typename R> struct plus;
+  // props
+  template <typename L, typename R>
+  struct set_props < category::pw, pw::plus<L, R> >
+  {
+    typedef ntg_return_type(plus,
+			    oln_pw_type_of(L, value),
+			    oln_pw_type_of(R, value)) value_type;
+  };
 
-    template <typename L, typename R>
-    struct traits < plus<L, R> >
-    {
-      typedef abstract::binary_function<L, R, plus<L, R> > super_type;
-      typedef typename traits<super_type>::point_type point_type;
-      typedef typename traits<super_type>::size_type  size_type;
-      typedef ntg_return_type(plus,
-			      oln_pw_value_type(L),
-			      oln_pw_value_type(R)) value_type;
-    };
 
+  namespace pw {
+
     template <typename L, typename R>
     struct plus : public abstract::binary_function < L, R, plus<L, R> >
     {
       typedef plus<L, R> self_type;
 
-      typedef oln_pw_point_type(self_type) point_type;
-      typedef oln_pw_value_type(self_type) value_type;
-      typedef oln_pw_size_type(self_type)  size_type;
+      typedef oln_pw_type_of(self_type, point) point_type;
+      typedef oln_pw_type_of(self_type, value) value_type;
+      typedef oln_pw_type_of(self_type, size)  size_type;
 
       typedef abstract::binary_function<L, R, self_type> super_type;
 
Index: oln/core/pw/macros.hh
===================================================================
--- oln/core/pw/macros.hh	(revision 130)
+++ oln/core/pw/macros.hh	(working copy)
@@ -30,11 +30,6 @@
 
 
 
-# define oln_pw_point_type(F) typename oln::pw::traits<F>::point_type
-# define oln_pw_value_type(F) typename oln::pw::traits<F>::value_type
-# define oln_pw_size_type(F)  typename oln::pw::traits<F>::size_type
-
-
 // FIXME: rename?
 # define oln_pw_operator(NAME, SYMBOL, TYPE)			\
 template <typename L>						\
Index: oln/core/pw/abstract/function.hh
===================================================================
--- oln/core/pw/abstract/function.hh	(revision 130)
+++ oln/core/pw/abstract/function.hh	(working copy)
@@ -29,18 +29,53 @@
 # define OLENA_CORE_PW_ABSTRACT_FUNCTION_HH
 
 # include <mlc/any.hh>
-# include <oln/core/properties.hh>
-# include <oln/core/pw/macros.hh>
+# include <oln/core/abstract/image.hh>
+# include <oln/core/typedefs.hh>
 
 
+# define oln_pw_type_of(PointWiseType, Alias) \
+mlc_type_of(oln, oln::category::pw, PointWiseType, Alias)
+
+
 namespace oln {
 
 
-  namespace pw { // means "point-wise"
+  namespace category
+  {
+    struct pw; // means "point-wise"
+  }
 
-    template <typename T> struct traits;
 
+  template <>
+  struct set_default_props < category::pw >
+  {
+    typedef mlc::undefined_type point_type;
+    typedef mlc::undefined_type value_type;
+    typedef mlc::undefined_type size_type;
+  };
 
+
+  template <typename PWF>
+  struct get_props < category::pw, PWF >
+  {
+    typedef oln_pw_type_of(PWF, point) point_type;
+    typedef oln_pw_type_of(PWF, value) value_type;
+    typedef oln_pw_type_of(PWF, size)  size_type;
+
+    static void echo(std::ostream& ostr)
+    {
+      ostr << "props_of( oln::category::pw, " << mlc_to_string(PWF) << " ) =" << std::endl
+	   << "{" << std::endl
+	   << "\t point_type = " << mlc_to_string(point_type) << std::endl
+	   << "\t value_type = " << mlc_to_string(value_type) << std::endl
+	   << "\t size_type  = " << mlc_to_string(size_type)  << std::endl
+	   << "}" << std::endl;
+    }
+  };
+
+
+  namespace pw {
+
     // fwd decls
     namespace abstract {
       template <typename E> struct function;
@@ -50,22 +85,14 @@
     template <typename F> struct not_;
 
 
-    template <typename E>
-    struct traits < abstract::function<E> >
-    {
-      typedef oln_pw_point_type(E) point_type;
-      typedef oln_pw_value_type(E) value_type;
-      typedef oln_pw_size_type(E)  size_type;
-    };
-
     namespace abstract {
 
       template <typename E>
       struct function : public mlc::any<E>
       {
-	typedef oln_pw_point_type(E) point_type;
-	typedef oln_pw_value_type(E) value_type;
-	typedef oln_pw_size_type(E)  size_type;
+	typedef oln_pw_type_of(E, point) point_type;
+	typedef oln_pw_type_of(E, value) value_type;
+	typedef oln_pw_type_of(E, size)  size_type;
 
 	const size_type& size() const
 	{
Index: oln/core/pw/abstract/binary_function.hh
===================================================================
--- oln/core/pw/abstract/binary_function.hh	(revision 130)
+++ oln/core/pw/abstract/binary_function.hh	(working copy)
@@ -37,32 +37,40 @@
 namespace oln {
 
 
-  namespace pw { // means "point-wise"
-
-
-    // fwd decls
+  // fwd decl
+  namespace pw {
     namespace abstract {
       template <typename L, typename R, typename E> struct binary_function;
     }
+  }
 
+  // super type
+  template <typename L, typename R, typename E>
+  struct set_super_type < pw::abstract::binary_function<L, R, E> > { typedef pw::abstract::function<E> ret; };
 
-    template <typename L, typename R, typename E>
-    struct traits < abstract::binary_function<L, R, E> >
-    {
-      typedef oln_pw_point_type(L) left_point_type;
-      typedef oln_pw_point_type(R) right_point_type;
+  // props
+  template <typename L, typename R, typename E>
+  struct set_props < category::pw, pw::abstract::binary_function<L, R, E> >
+  {
+    typedef oln_pw_type_of(L, point) left_point_type;
+    typedef oln_pw_type_of(R, point) right_point_type;
+    
+    typedef oln_point_type_from_2(left_point_type, right_point_type) point_type;
+    
+    typedef oln_pw_type_of(L, size) left_size_type;
+    typedef oln_pw_type_of(R, size) right_size_type;
+    
+    typedef oln_size_type_from_2(left_size_type, right_size_type) size_type;
+  };
 
-      typedef oln_point_type_from_2(left_point_type, right_point_type) point_type;
 
-      typedef oln_pw_size_type(L) left_size_type;
-      typedef oln_pw_size_type(R) right_size_type;
 
-      typedef oln_size_type_from_2(left_size_type, right_size_type) size_type;
-    };
+  namespace pw {
 
-
     namespace abstract {
 
+
+      // internals
       namespace internal {
 
 	template <typename T1, typename T2>
@@ -95,6 +103,8 @@
       } // end of namespace oln::pw::abstract::internal
 
 
+
+
       template <typename L, typename R, typename E>
       struct binary_function : public function<E>
       {
@@ -112,11 +122,11 @@
 	}
 
 	typedef abstract::binary_function<L, R, E> self_type;
-	typedef oln_pw_point_type(self_type) point_type;
-	typedef oln_pw_size_type(self_type)  size_type;
+	typedef oln_pw_type_of(self_type, point) point_type;
+	typedef oln_pw_type_of(self_type, size)  size_type;
 
-	typedef internal::binary_function_helper<oln_pw_size_type(L),
-						 oln_pw_size_type(R) > _helper_type;
+	typedef internal::binary_function_helper<oln_pw_type_of(L, size),
+						 oln_pw_type_of(R, size) > _helper_type;
 
 	const size_type& impl_size() const
 	{
Index: oln/core/pw/minus.hh
===================================================================
--- oln/core/pw/minus.hh	(revision 130)
+++ oln/core/pw/minus.hh	(working copy)
@@ -31,35 +31,40 @@
 # include <oln/core/pw/abstract/binary_function.hh>
 # include <oln/core/pw/literal.hh>
 # include <ntg/all.hh>
+# include <oln/core/pw/macros.hh>
 
 
 namespace oln {
 
+  // fwd decl
+  namespace pw {
+    template <typename L, typename R> struct minus;
+  }
 
-  namespace pw { // means "point-wise"
+  // super type
+  template <typename L, typename R>
+  struct set_super_type < pw::minus<L, R> > { typedef pw::abstract::binary_function<L, R, pw::minus<L, R> > ret; };
 
-    // fwd decl
-    template <typename L, typename R> struct minus;
+  // props
+  template <typename L, typename R>
+  struct set_props < category::pw, pw::minus<L, R> >
+  {
+    typedef ntg_return_type(minus,
+			    oln_pw_type_of(L, value),
+			    oln_pw_type_of(R, value)) value_type;
+  };
 
-    template <typename L, typename R>
-    struct traits < minus<L, R> >
-    {
-      typedef abstract::binary_function<L, R, minus<L, R> > super_type;
-      typedef typename traits<super_type>::point_type point_type;
-      typedef typename traits<super_type>::size_type  size_type;
-      typedef ntg_return_type(minus,
-			      oln_pw_value_type(L),
-			      oln_pw_value_type(R)) value_type;
-    };
 
+  namespace pw {
+
     template <typename L, typename R>
     struct minus : public abstract::binary_function < L, R, minus<L, R> >
     {
       typedef minus<L, R> self_type;
 
-      typedef oln_pw_point_type(self_type) point_type;
-      typedef oln_pw_value_type(self_type) value_type;
-      typedef oln_pw_size_type(self_type)  size_type;
+      typedef oln_pw_type_of(self_type, point) point_type;
+      typedef oln_pw_type_of(self_type, value) value_type;
+      typedef oln_pw_type_of(self_type, size)  size_type;
 
       typedef abstract::binary_function<L, R, self_type > super_type;
 
@@ -82,10 +87,10 @@
     namespace abstract {
 
       template <typename E>
-      minus<literal<oln_pw_value_type(E)>, E>
+      minus<literal<oln_pw_type_of(E, value)>, E>
       function<E>::operator-() const
       {
-	typedef literal<oln_pw_value_type(E)> lit_type;
+	typedef literal<oln_pw_type_of(E, value)> lit_type;
 	static const lit_type lhs = 0;
 	minus< lit_type, E> tmp(lhs, this->exact());
 	return tmp;
Index: oln/core/pw/literal.hh
===================================================================
--- oln/core/pw/literal.hh	(revision 130)
+++ oln/core/pw/literal.hh	(working copy)
@@ -35,20 +35,27 @@
 
 namespace oln {
 
+  // fwd decl
+  namespace pw {
+    template <typename T> struct literal;
+  }
 
-  namespace pw { // means "point-wise"
+  // super type
+  template <typename T>
+  struct set_super_type < pw::literal<T> > { typedef pw::abstract::function< pw::literal<T> > ret; };
 
-    // fwd decl
-    template <typename T> struct literal;
+  // props
+  template <typename T>
+  struct set_props < category::pw, pw::literal<T> >
+  {
+    typedef any_point point_type;
+    typedef T         value_type;
+    typedef any_size  size_type;
+  };
 
-    template <typename T>
-    struct traits < literal<T> >
-    {
-      typedef any_point point_type;
-      typedef T         value_type;
-      typedef any_size  size_type;
-    };
 
+  namespace pw {
+
     template <typename T>
     struct literal : public abstract::function < literal<T> >
     {
Index: oln/core/pw/logic.hh
===================================================================
--- oln/core/pw/logic.hh	(revision 130)
+++ oln/core/pw/logic.hh	(working copy)
@@ -36,9 +36,8 @@
 namespace oln {
 
 
-  namespace pw { // means "point-wise"
+  namespace pw {
 
-
     // FIXME: move somewhere else
     namespace internal
     {
@@ -86,27 +85,39 @@
       };
     } // end of oln::pw::internal
 
+  } // end of namespace oln::pw
 
 
-    // fwd decl
+  // fwd decl
+  namespace pw {
     template <typename R> struct not_;
+  }
 
-    template <typename R>
-    struct traits < not_<R> >
-    {
-      typedef oln_pw_point_type(R) point_type;
-      typedef oln_pw_size_type(R) size_type;
-      typedef bool value_type;
-    };
+  // super type
+  template <typename R>
+  struct set_super_type < pw::not_<R> > { typedef pw::abstract::function < pw::not_<R> > ret; };
 
+  // props
+  template <typename R>
+  struct set_props < category::pw, pw::not_<R> >
+  {
+    typedef oln_pw_type_of(R, point) point_type;
+    typedef oln_pw_type_of(R, size)  size_type;
+    typedef bool value_type;
+  };
+
+
+  namespace pw
+  {
+
     template <typename R>
     struct not_ : public abstract::function < not_<R> >
     {
       typedef not_<R> self_type;
 
-      typedef oln_pw_point_type(self_type) point_type;
-      typedef oln_pw_value_type(self_type) value_type;
-      typedef oln_pw_size_type(self_type)  size_type;
+      typedef oln_pw_type_of(R, point) point_type;
+      typedef oln_pw_type_of(R, size)  size_type;
+      typedef oln_pw_type_of(R, value) value_type;
 
       R right;
 
@@ -146,7 +157,7 @@
       not_<E>
       function<E>::operator!() const
       {
-	mlc::eq< oln_typeness_of(oln_pw_value_type(E)), typeness::binary_tag >::ensure();
+	mlc::eq< oln_typeness_of(oln_pw_type_of(E, value)), typeness::binary_tag >::ensure();
 	not_<E> tmp(this->exact());
 	return tmp;
       }
Index: oln/core/pw/cmp.hh
===================================================================
--- oln/core/pw/cmp.hh	(revision 130)
+++ oln/core/pw/cmp.hh	(working copy)
@@ -29,12 +29,13 @@
 # define OLENA_CORE_PW_CMP_HH
 
 # include <oln/core/pw/abstract/binary_function.hh>
+# include <oln/core/pw/macros.hh>
 
 
 namespace oln {
 
 
-  namespace pw { // means "point-wise"
+  namespace pw {
 
 
     // FIXME: move somewhere else
@@ -80,29 +81,41 @@
 
 
 
-    // fwd decl
+  } // end of namespace pw
+
+
+  // fwd decl
+  namespace pw {
     template <typename L, typename R, typename C> struct cmp;
+  }
 
-    template <typename L, typename R, typename C>
-    struct traits < cmp<L, R, C> >
-    {
-      typedef abstract::binary_function<L, R, cmp<L, R, C> > super_type;
-      typedef typename traits<super_type>::point_type point_type;
-      typedef typename traits<super_type>::size_type  size_type;
-      typedef bool value_type;
-    };
+  // super type
+  template <typename L, typename R, typename C>
+  struct set_super_type < pw::cmp<L, R, C> > { typedef pw::abstract::binary_function<L, R, pw::cmp<L, R, C> > ret; };
 
+  // props
+  template <typename L, typename R, typename C>
+  struct set_props < category::pw, pw::cmp<L, R, C> >
+  {
+    typedef bool value_type;
+  };
 
+
+
+  
+  namespace pw
+  {
+
     template <typename L, typename R, typename C>
     struct cmp : public abstract::binary_function < L, R, cmp<L, R, C> >
     {
       typedef cmp<L, R, C> self_type;
 
-      typedef oln_pw_point_type(self_type) point_type;
-      typedef oln_pw_size_type(self_type)  size_type;
-      typedef oln_pw_value_type(self_type) value_type;
+      typedef oln_pw_type_of(self_type, point) point_type;
+      typedef oln_pw_type_of(self_type, value) value_type;
+      typedef oln_pw_type_of(self_type, size)  size_type;
 
-      typedef abstract::binary_function < L, R, self_type > super_type;
+      typedef abstract::binary_function<L, R, self_type> super_type;
 
       cmp(const abstract::function<L>& left,
 	  const abstract::function<R>& right) :
Index: oln/core/any/point.hh
===================================================================
--- oln/core/any/point.hh	(revision 130)
+++ oln/core/any/point.hh	(working copy)
@@ -28,6 +28,7 @@
 #ifndef OLENA_CORE_ANY_POINT_HH
 # define OLENA_CORE_ANY_POINT_HH
 
+# include <iostream> 
 # include <oln/core/abstract/point.hh>
 # include <oln/core/abstract/dpoint.hh>
 
@@ -38,13 +39,9 @@
   struct any_point;
   struct any_dpoint;
 
-  // category
-  template <>
-  struct set_category< any_point > { typedef category::point ret; };
-
   // props
   template <>
-  struct set_props < category::point, any_point > : public props_of<category::point>
+  struct set_props < category::point, any_point >
   {
     typedef any_dpoint dpoint_type;
   };
